<template>
    <div class="contenedor">
        <div :id="name_id" :style="filtros.styleObject"></div>
    </div>
</template>

<script>

import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";

am4core.useTheme(am4themes_animated);

export default {
    name: "GraficaBarraSemana",
    props: {
        name_id: String
    },
    data() {
        return {
            chart: null,
            filtros: {
                        value : 0,
                        target : 0,
                        categoria : "Categoria",
                        name_id: "",
                        datos : [{}],
                        styleObject: {
                            width: "100%",
                            height: "310px",
                            margin: "auto"
                        },
                        rColores: [],
                        rCalf: [],
            },
        };
    }, 
    methods: {
        initChartG(){
            am4core.useTheme(am4themes_animated);
            var chart = am4core.create(this.filtros.name_id, am4charts.XYChart);
            chart.logo.hidden = true;
            chart.paddingRight = 25;
         
            chart.numberFormatter.numberFormat = "##";
            //chart.numberFormatter.numberFormat = "#.#'%'";
            chart.data = this.filtros.datos;

            // Create axes
            var categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
            categoryAxis.dataFields.category = "semana";
            categoryAxis.renderer.grid.template.location = 0;
            categoryAxis.renderer.minGridDistance = 10;

            var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
            valueAxis.title.text = "Programacion y Realizado";
            valueAxis.title.fontWeight = 800;



            // Create series
            var series = chart.series.push(new am4charts.ColumnSeries());
            series.dataFields.valueY = "programacion";
            series.dataFields.categoryX = "semana";
            series.clustered = false;
            series.tooltipText = "Programado: [bold]{valueY}[/]"
            //series.tooltipText = "Programado en la semana {categoryX}: [bold]{valueY}[/]"
            series.columns.template.strokeWidth = 0;
            series.columns.template.fill = new am4core.InterfaceColorSet().getFor( "alternativeBackground");
            series.columns.template.fillOpacity = 0.28;
            series.columns.template.strokeWidth = 0;
            /*
            series.columns.template.adapter.add("fill", function (fill, target) {
                return am4core.color("#ffcd00"); 
                //return am4core.color("#707070"); 
            });
            */
            //series.tooltipText = "GDP grow in {categoryX} (2004): [bold]{valueY}[/]";

            var series2 = chart.series.push(new am4charts.ColumnSeries());
            series2.dataFields.valueY = "realizado";
            series2.dataFields.categoryX = "semana";
            series2.clustered = false;
            series2.columns.template.width = am4core.percent(50);
            series2.tooltipText = "Realizado: [bold]{valueY}[/]"
            //series2.tooltipText = "Realizado en la semana {categoryX}: [bold]{valueY}[/]"
            series2.columns.template.strokeWidth = 0;
            series2.columns.template.adapter.add("fill", function (fill, target) {
                return am4core.color("#ffcd00"); 
                //return am4core.color("#707070"); 
            });
            /*
            series2.columns.template.fill = new am4core.InterfaceColorSet().getFor( "alternativeBackground");
            series2.columns.template.fillOpacity = 0.28;
            series2.columns.template.strokeWidth = 0;
            */
            //series2.tooltipText = "GDP grow in {categoryX} (2005): [bold]{valueY}[/]";

            chart.cursor = new am4charts.XYCursor();
            chart.cursor.lineX.disabled = true;
            chart.cursor.lineY.disabled = true;

            var label2 = chart.createChild(am4core.Label);
            label2.text =  "Semanas";
            label2.fontSize = 14;
            label2.align = "center";
            label2.isMeasured = false;
            label2.x = am4core.percent(50);
            label2.y = am4core.percent(100);
            label2.horizontalCenter = "middle";
            label2.fontWeight = "bold";
            
            this.chart = chart;
        },





            
        setValores(filtros) {
            this.filtros=filtros;
            this.initChartG();
        },

    },
    mounted() {
        this.filtros.name_id = this.name_id ;
    },
    beforeDestroy(){
        if(this.chart!=null) {
            this.chart.dispose(); 
        }
    }
    
}
</script>
<style >


</style>